image: node:latest

stages:
  - test
  - tagAndPublish

test:
  stage: test
  only:
    - merge_requests
  script:
    - npm ci
    - npm i -g nyc mocha typescript gulp tslint
    - gulp fullTest


tagAndPublish:
  stage: tagAndPublish
  only:
    refs:
      - master
  script:  
    - npm ci
    - npm i -g nyc mocha typescript gulp tslint
    - gulp fullTest
    - apt-get update
    - apt-get install -y openssh-server
    - service ssh start
    - mkdir ~/.ssh && chmod 700 ~/.ssh && touch ~/.ssh/known_hosts
    - eval $(ssh-agent -s)
    - ssh-keyscan -t rsa gitlab.com >> ~/.ssh/known_hosts
    - echo "$GIT_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null   
    - git remote add gitlab git@gitlab.com:vlr/validity.git
    - export VERSION=$(gulp createTag --silent)    
    - echo $VERSION
    - git tag $VERSION    
    - git push gitlab $VERSION
    - gulp applyVersion
    - echo "//registry.npmjs.org/:_authToken=$NPM_AUTH_TOKEN">.npmrc
    - npm publish --access=public    
  